#include "GameCharacter.h"
#include "Dice.h"

GameCharacter::GameCharacter() : posX(0), posY(0), hitPoints(10), weapon(nullptr) {
    // load bitmap
    // work
    // ...
    // more work
}

GameCharacter::GameCharacter(int x, int y, int hp, Weapon* w) : posX(x), posY(y), hitPoints(hp), weapon(w) {
    // load bitmap
    // work
    // ...
    // more work
}

GameCharacter::~GameCharacter() {
    if (weapon != nullptr)
        delete weapon;
}


GameCharacter &GameCharacter::operator=(GameCharacter &right) {
    if (this != &right) {
        posX = right.posX;
        posY = right.posY;
        hitPoints = right.hitPoints;

        if (weapon != nullptr)
            delete weapon;
        if (right.weapon != nullptr)
            weapon = new Weapon(*(right.weapon));
        else
            weapon = nullptr;
    }
    return *this;
}


void GameCharacter::move(int x, int y) {
    posX += x;
    posY += y;
}

void GameCharacter::fight(GameCharacter &enemy) {
    int damage = 1;
    if (weapon != nullptr)
        damage = weapon->useWeapon();
    Dice aDice(6);
    if (aDice.throwDice() <= 2)
        damage = 0; // miss hit if dice roll <= 2
    int newHitPoints = enemy.getHitPoints() - damage;
    enemy.setHitPoints(newHitPoints);
}