#ifndef DANDD_GAMECHARACTER_H
#define DANDD_GAMECHARACTER_H

#include "Weapon.h"

class GameCharacter {
public:
    GameCharacter();

    GameCharacter(int x, int y, int hp = 10, Weapon* w = nullptr);

    GameCharacter(GameCharacter &orig);  // TODO implement
    virtual ~GameCharacter();

    GameCharacter &operator=(GameCharacter &right);

    virtual void move(int x, int y);

    virtual void fight(GameCharacter &enemy);

    int getPosX() const {
        return posX;
    }

    void setPosX(int posX) {
        GameCharacter::posX = posX;
    }

    int getPosY() const {
        return posY;
    }

    void setPosY(int posY) {
        GameCharacter::posY = posY;
    }

    int getHitPoints() const {
        return hitPoints;
    }

    void setHitPoints(int hitPoints) {
        if (hitPoints < 0)
            hitPoints = 0;
        GameCharacter::hitPoints = hitPoints;
    }

    Weapon* getWeapon() const {
        return weapon;
    }

    void setWeapon(Weapon* weapon) {
        GameCharacter::weapon = weapon;
    }

protected:
    int posX;
    int posY;
    int hitPoints;
    Weapon* weapon;
};


#endif //DANDD_GAMECHARACTER_H
